/************************************************************************
/*				   		"CONNETED" LIBRARY
/*				INCLUDES ALL THE INLINE FINCTIONS
//**********************************************************************/
#pragma inline

////////////////////// FUNCTION DECLARATION ////////////////////////////////

void ASK_PORT(void);  //ask the user COM port

void SET_BAUD_RATE(void);  //ask the baud rate from the user
						  // and give LSB and MSB to the next function

void INITIALIZE(void); //initializes the modem with the value in LSB and MSB

void SEND_STRING(char *,int ); //send any string to the modem
								//	(not to be shown in the main windows);
void EXIT(void);   // exit the program while caling the hangup

void DISPLAY_STRING(void); //simple DOS 21h function to diaplay any string

void CLEAR_SCREEN(void);

void ENTER_PRESSED(void);//MOVING THE CURSOR TO THE NEW LINE WHEN ENTER PRESSED

void SCROLL_UP(void); //SCROLL UP THE WINDOWS WHEN THE SCREEN FILLS

void SET_CURSOR(void);// MOVE THE CURSOR ONE COLUMN

void HANG_UP(void);	//HANGUP THE MODEM

void IF_BUFFER_EMPTY(void);	//if the TBR and THR registers are empty then
							// transmitt another character

void ANSWER(void);	//answer the incoming call

void draw(void);	//for interface

void BACK_SPACE(void);	//when the backspace is pressed
//////////////////////////////////////////////////////////////////////////
char FOR_LSB, //value for the LSB register
	 FOR_MSB, //value for the MSB register
	 CUR_ROW,//the current row in the program
	 CUR_COL;//the current col in the program


int PORT,		//port address
	L_CTRL,	    //line contro register
	M_CTRL,		//modem control register
	M_STAT,		//modem status register
	L_STAT,		//line status register
	TR,			//transmitter register
	RC,			//recieving register
	LSB,		//register to hold the LSB values
	MSB;		//register to hold the MSB values

///////////////////////////////////////////////////////////////////////////
//					ASK FOR THE COMM PORT
//  	  present a menu to the user and ask the port
//
///////////////////////////////////////////////////////////////////////////

void ASK_PORT(void)
{
	char   FOR_PORT[]="\n\r\n\r\n\r\t\t\t\tCHOOSE PORT\n\r\n\r\t\t[1]   COMM1\n\r\n\r\t\t[2]   COMM2$";
	char   NO_MODEM[]="Sorry no modem present.....$";

	clrscr();

	asm		LEA     DX,FOR_PORT
	DISPLAY_STRING();

	asm		MOV     AH,1	//ask for choice
	asm		INT     21H

	asm		CMP     AL,'1'	//if COM1 selected,goto  FOR_COM1
	asm		JE      FOR_COM1

	asm		CMP     AL,'2'	//if COM1 selected,goto  FOR_COM2
	asm		JE      FOR_COM2

	ASK_PORT();				//if no port given,ask again

   FOR_COM2:
	//GIVE THE REGISTER THEIR VALUES ACCORDING TO THE PORT ADRESS

	asm		MOV     DX,2feh
	asm		IN      AL,DX

	asm		CMP     AL,30H          //CHECK THE STATUS
	asm		JNE     exit2           //IF MODEM PRESENT THE CONTINUE,
									  //ELSE goto "EXIT2" DISPLAY STRING AND EXIT
	asm		MOV     PORT,2F8H
	asm		MOV     L_CTRL,2F8H+3H    // ;LINE CONTROL REGISTER
	asm		MOV     M_CTRL,2F8H+4H    // ;MODEM CONTROL REGISTER
	asm		MOV     L_STAT,2F8H+5H    // ;LINE STATUS REGISTER
	asm		MOV     M_STAT,2F8H+6H    // ;MODEM STATUS REGISTER
	asm		MOV     TR,2F8H+0H        // ;TRANSMITTER HOLDER REGISTER
	asm		MOV     RC,2F8H+0H        // ; RECIEVER REGISTER
	asm		MOV     LSB,2F8H+0H       // ;FOR DLL i.e BAUD RATE
	asm		MOV     MSB,2F8H+1H       // ;FOR MDD i.e BAUD RATE

	asm		JMP		BYE               //GOTO BYE
	CLEAR_SCREEN();

   FOR_COM1:                          //COME HERE IS "COM1" SELECTED

	asm		MOV     DX,3FEh
	asm		IN      AL,DX

	asm		CMP		AL,30h            //CHECK THE STATUS
	asm		JNE     exit2             //IF PRESENT THE CONTINUE,
									  //ELSE goto "EXIT2" DISPLAY STRING AND EXIT

	asm		MOV     PORT,3F8H
	asm		MOV     L_CTRL,3F8H+3H    //  ;LINE CONTROL REGISTER
	asm		MOV     M_CTRL,3F8H+4H    //  ;MODEM CONTROL REGISTER
	asm		MOV     L_STAT,3F8H+5H    //  ;LINE STATUS REGISTER
	asm		MOV     M_STAT,3F8H+6H    //  ;MODEM STATUS REGISTER
	asm		MOV     TR,3F8H+0H        // ;TRANSMITTER HOLDER REGISTER
	asm		MOV     RC,3F8H+0H        // ; RECIEVER REGISTER
	asm		MOV     LSB,3F8H+0H       // ;FOR DLL i.e BAUD RATE
	asm		MOV     MSB,3F8H+1H       // ;FOR MDD i.e BAUD RATE
	asm		JMP		BYE

	exit2:
	CLEAR_SCREEN();

	asm		LEA     DX,NO_MODEM		//display a string and exit
	DISPLAY_STRING();
	getch();
	EXIT();

   BYE:							//come here is either modem is present
								// on COM1 or COM2
}


///////////////////////////////////////////////////////////////////////////
//					ASK FOR THE BAUD RATE
//		set the baud rate of the modem and put the given values in the
// 		FOR_LSB and FOR_MSB to be processed by the INITIALZE() function
///////////////////////////////////////////////////////////////////////////


void SET_BAUD_RATE(void)
{

	char FOR_BAUD_RATE[]="\n\r\n\r\n\r\t\t\t\tCHOOSE BAUD RATE\n\r\n\r\t\t[1]   2,400\n\r\n\r\t\t[2]   9,600\n\r\n\r\t\t[3]   19,200\n\r\n\r\t\t[4]   38,400\n\r\n\r\t\t[5]   57,600$";
	char l,m;

	clrscr();

	asm		LEA     DX,FOR_BAUD_RATE      //  DISPLAY THE BAUD RATE MENU

	DISPLAY_STRING();

	asm		MOV     AH,1                  //  INPUT THE CHOICE
	asm		INT     21H

	asm		CMP     AL,'1'         		 // FOR    2400
	asm		JNE     L19200

	asm		MOV     FOR_LSB,30H
	asm		MOV     FOR_MSB,00H
	asm		JMP     OK

   L19200:
	asm		CMP     AL,'3'        		 //FOR 19200
	asm		JNE     L38400

	asm		MOV     FOR_LSB,06H
	asm		MOV     FOR_MSB,00H
	asm		JMP     OK

   L38400:
	asm		CMP     AL,'4'        		// FOR 38400
	asm		JNE     L57600

	asm		MOV     FOR_LSB,03H
	asm		MOV     FOR_MSB,00H
	asm		JMP     OK

   L57600:
	asm		CMP     AL,'5'        		 //FOR 57600
	asm		JNE     L9600

	asm		MOV     FOR_LSB,02H
	asm		MOV     FOR_MSB,00H
	asm		JMP     OK


   L9600:			//this automatically chosen when non other is selected
	asm		MOV     FOR_LSB,0CH
	asm		MOV     FOR_MSB,00H

	OK:
}

///////////////////////////////////////////////////////////////////////////
//					INITIALIZE THE MODEM
///////////////////////////////////////////////////////////////////////////

void INITIALIZE(void)
{
	asm	push    ax
	asm	push    dx
	asm	push    si
	asm	push	di

	asm	mov     al,10000000b    //SET BIT 8 FOR BAUD PATCHES
	asm	mov     dx,L_CTRL
	asm	out     dx,al

	asm	mov     dx,LSB    //SET THE LSB REGISTER
	asm	mov     al,FOR_LSB
	asm	out     dx,al

	asm	mov     dx,MSB   //SET THE MSB REFISTER
	asm	mov     al,FOR_MSB
	asm	out     dx,al

	asm	mov     dx,L_CTRL	//set 8 stop bit,no parity
	asm	mov     al,00000011b
	asm	out     dx,al

	asm   mov     dx,M_CTRL //set the CTS and DSR ready
	asm   mov     al,3
	asm   out     dx,al

	asm	pop		di
	asm	pop     si
	asm	pop     dx
	asm	pop     ax

}
///////////////////////////////////////////////////////////////////////////
//					FOR CHATTING
///////////////////////////////////////////////////////////////////////////
void CHAT(void)
{
   clrscr();
   draw();		//draw the menu

   FOR:			//main loop

	asm		MOV     AH,6            //   ;INPUT WITHOUT ECHO
	asm		MOV     DL,0FFH
	asm		INT     21H

	asm		JZ      NO_CHARS         //IF NO INPUT GO TO THE END OF LOOP

	asm		CMP     AL,0DH			//for enter
	asm		JE      ENTER_OUT

	asm		CMP		AL,10h			// ctrl - h for hanging up
	asm		JE		hang

	asm		CMP		AL,8h			 // ctrl - h for hanging up
	asm		JE		BACKSPACE

	asm		CMP     AL,1            // for answering the call
	asm		JE		ANSWER

	asm		MOV     AH,9            //OUTPUT THE CHAR FOR ECHO PURPOSE
	asm		mov		bh,0
	asm		mov     BL,1110B       //in yellow color
	asm		MOV		CX,1
	asm		INT     10H

	asm		CMP     AL,05H           // ;CTRL-E FOR EXIT
	asm		JE      OOPS

	SET_CURSOR();                   //since the ah,9 doesn't move the cursor
									//to the next column,therfor we call this

	back_hang:		//this label is used comming back after hanging up

   BACK1: 		                 // ;BACK AFTER THE ENTER_OUT

	asm		MOV     DX,PORT      //MOVE THE PORT NUMBER I.E 2F8
	asm		OUT     DX,AL        // ; OUTPUT THE CHAR TO THE 2F8

	IF_BUFFER_EMPTY();         //check is the character has been sent

   NO_CHARS:                    //this label is used when no character is
							   //pressed in the begining i.e. at the FOR loop


	asm		   MOV     DX,L_STAT            //check line statues register
	//								to chheck is any charachter is wating in the modem
	asm		   IN      AL,DX                 //  ;LINE STATUS REGISTER
	asm		   TEST    AL,00000001B       //     ;CHECK TO SEE IF RBR IS FULL
	asm		   JNZ     ON_SCREEN        //if yes,print it,goto ON_SCREEN

   BACK_FROM_ON_SCREEN:		//coming back from ON_SCEEN

	asm		   MOV      AH,3      //GETTING THE CURSOR POSITION
	asm		   MOV      BH,0      //if it is at the boundary of the screen
	asm		   INT      10H
	asm		   CMP      DL,79      //IF THELINE IS FULL,GO TO THE NEXT LINE
	asm		   JE       ENTER_OUT

 BACK_AFTER_NEW_LINE:
	asm		   CMP		DH,24	//if the screen is full,scroll up
	asm		   JE		SCROLL

 BACK_FROM_SCROLL://coming back from scroll

	asm		   JMP     FOR //END OF THE MAIN LOOP; GO TO THE BEGTINNING OF THE LOOP

//   ;///////////////////////////////////////////////////////////////;

   ON_SCREEN:		//for printing the characher received

	asm		MOV     DX,PORT
	asm		IN      AL,DX        //  ;GET FROM PORT

	asm		CMP     AL,0DH      //if enter
	asm		JE      ENTER_IN

	asm		CMP		AL,10      //a filter
	asm		JE		BACK2

	asm		MOV     AH,9        //  ;OUTPUT THE CHAR
	asm		MOV		BH,0
	asm		MOV		BL,1010B	//green color
	asm		MOV		CX,1
	asm		INT     10H

	SET_CURSOR();          //move to the next column

 BACK2:
	asm		JMP     BACK_FROM_ON_SCREEN  //go back to the main FOR loop

//	   ;////////////////////// FOR THE NEW LINE AFTER ENTER///////////

	BACKSPACE:	//for back space
	BACK_SPACE();
	asm		JMP 	FOR //go back to the main loop

	ENTER_IN:
	ENTER_PRESSED();
	asm		jmp		BACK2

	ENTER_OUT:
	ENTER_PRESSED();
	asm		jmp		BACK1

	hang:             //for hanging up the modem when ctrl_h is pressed
	HANG_UP();
	asm		JMP		FOR //go back to the main loop

	SCROLL:            //for scroling the window
	SCROLL_UP();
	asm		JMP		FOR //go back to the main loop

	ANSWER:			  //for answering the modem when ctrl_a is pressed
	ANSWER();
	asm		JMP		FOR //go back to the main loop

//	;////////////////////// FOR EXIT WHEN "CTRL-E" PRESSED///////////

	 OOPS:          //when ctrl_e is pressed
	 HANG_UP();		//hang up before exiting
}

///////////////////////////////////////////////////////////////////////////
//						send string do the modem
///////////////////////////////////////////////////////////////////////////

void SEND_STRING(char *str,int string_length)
{

	asm		MOV     CX,string_length
	asm		MOV		DI,str


GO:
	asm			MOV     DX,2F8H
	asm			MOV     AL,[DI]
	asm			OUT     DX,AL   //send the charachter to the port

   HOLD:		//hold untill the char is sent
	asm			MOV     AH,3
	asm			MOV     DX,1
	asm			INT     14H
	asm			TEST    AH,00100000B
	asm			JZ      HOLD

	asm			INC     DI
	asm			LOOP    GO
}

///////////////////////////////////////////////////////////////////////////
///					FOR NEW LINE WHEN THE ENTER IS PRESSED
///////////////////////////////////////////////////////////////////////////

void ENTER_PRESSED(void)
{
	asm	push    ax
	asm	push    dx
	asm	push    si
	asm	push    di

	asm		MOV     AH,3
	asm		MOV     BH,0
	asm		INT     10H
	asm		MOV     CUR_ROW,DH
	asm		INC     CUR_ROW

	asm		MOV     AH,2
	asm		MOV     DH,CUR_ROW
	asm		MOV     DL,0
	asm		MOV     BH,0
	asm		INT     10H

	asm	pop     di
	asm	pop     si
	asm	pop     dx
	asm	pop     ax

}

///////////////////////////////////////////////////////////////////////////
///					TO SCROLL THE WINDOWS UP
///////////////////////////////////////////////////////////////////////////

void SCROLL_UP(void)
{
	asm	push    ax
	asm	push    dx
	asm	push    si
	asm	push	di
	asm push	cx

	asm		mov     ah,6
	asm		mov     al,1
	asm		mov     ch,4
	asm		mov     cl,0
	asm		mov     dh,24
	asm		mov     dl,79
	asm		mov     dh,10000001b
	asm		int     10h

	asm		MOV     AH,2
	asm		MOV     DH,23
	asm		MOV     DL,0
	asm		MOV     BH,0
	asm		INT     10H

	asm pop		cx
	asm	pop     di
	asm	pop     si
	asm	pop     dx
	asm	pop     ax
}

///////////////////////////////////////////////////////////////////////////
///					FOR SETTING THE CURSOR AFTER THE ECHO i.e. TO THE RIGHT
///////////////////////////////////////////////////////////////////////////

void SET_CURSOR(void)
{
	asm	push    ax
	asm	push    dx
	asm	push    si
	asm	push    di

	asm		MOV     AH,3
	asm		MOV     BH,0
	asm		INT     10H
	asm		MOV		CUR_COL,DL
	asm		MOV		CUR_ROW,DH
	asm		INC		CUR_COL

	asm		MOV     AH,2
	asm		MOV     DH,CUR_ROW
	asm		MOV     DL,CUR_COL
	asm		MOV     BH,0
	asm		INT     10H

	asm	pop     di
	asm	pop     si
	asm	pop     dx
	asm	pop     ax

}

///////////////////////////////////////////////////////////////////////////
///					FOR HANGING UP
///////////////////////////////////////////////////////////////////////////

void  HANG_UP(void)
{
	char hang_1[] = "+++";
	char hang_2[] = "ath\r";

	delay(200);

	SEND_STRING(&hang_1[0],strlen(hang_1));

	delay(1000);

	SEND_STRING(&hang_2[0],strlen(hang_2));
}

///////////////////////////////////////////////////////////////////////////
///					FOR ANSWERING
///////////////////////////////////////////////////////////////////////////

void  ANSWER(void)
{
	char answer[] = "ata\r";

	SEND_STRING(&answer[0],strlen(answer));

}

///////////////////////////////////////////////////////////////////////////
///					WAIT TILL THE BUFFER IS EMPTY
///////////////////////////////////////////////////////////////////////////

void IF_BUFFER_EMPTY(void)
{
	asm	push    ax
	asm	push    dx
	asm	push    si
	asm	push    di

   CHECK_THR_EMPTY:

	asm		MOV     DX,L_STAT              // ; LINE STATUS REGISTER
	asm		IN      AL,DX
	asm		TEST    AL,00100000B          //  ;CHECK TO SEE IF TBR IS EMPTY
	asm		JZ      CHECK_THR_EMPTY

	CHECK_TBR_EMPTY:

	asm		MOV     DX,L_STAT             //  ; LINE STATUS REGISTER
	asm		IN      AL,DX
	asm		TEST    AL,01000000B          //  ;CHECK TO SEE IF TBR IS EMPTY
	asm		JZ      CHECK_TBR_EMPTY


	asm	pop     di
	asm	pop     si
	asm	pop     dx
	asm	pop     ax

}
///////////////////////////////////////////////////////////////////////////
//				CLEAR THE SCREEN
///////////////////////////////////////////////////////////////////////////

void CLEAR_SCREEN(void)
{
	asm	PUSH	AX
	asm	MOV		AH,0

	asm	MOV		AL,03H

	asm	INT		10H
	asm POP		AX

}
//////////////////////////////////////////////////////////////////////////
//					DISPLAY THE STRING WHOSE OFFSET IS IN DX
///////////////////////////////////////////////////////////////////////////

void DISPLAY_STRING(void)
{
	asm	push    ax
	asm	push    dx
	asm	push    si
	asm	push    di

	asm	mov     ah,9           // ;OUTPUT THE MENU
	asm	int     21h

	asm	pop     di
	asm	pop     si
	asm	pop     dx
	asm	pop     ax
}
///////////////////////////////////////////////////////////////////////////
//						EXIT
///////////////////////////////////////////////////////////////////////////

void EXIT(void)
{
	asm	push    ax
	asm	push    si
	asm	push    di

	CLEAR_SCREEN();

	asm	MOV		DX,PORT
	asm	MOV		AL,0
	asm	OUT		DX,AL
	asm	MOV     AX,4C00H
	asm	INT     21H

	asm	pop     di
	asm	pop     si
	asm	pop     ax

}
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//					BACK SPACE
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

void BACK_SPACE(void)
{
	asm	push    ax
	asm	push    dx
	asm	push    si
	asm	push    di

	asm		MOV     AH,3
	asm		MOV     BH,0
	asm		INT     10H
	asm		MOV		CUR_COL,DL
	asm		MOV		CUR_ROW,DH
	asm		DEC		CUR_COL

	asm		MOV     AH,2
	asm		MOV     DH,CUR_ROW
	asm		MOV     DL,CUR_COL
	asm		MOV     BH,0
	asm		INT     10H

	asm	pop     di
	asm	pop     si
	asm	pop     dx
	asm	pop     ax

}
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////