	TITLE   "IMRAN NAZIR JUENJO"

DOSSEG
.MODEL  SMALL
.STACK  100H

.DATA
	PORT    DW      ?         ;PORT ADRESS
	L_CTRL  DW      ?         ;LINE CONTROL REGISTER
	M_CTRL  DW      ?         ;MODEM CONTROL REGISTER
	L_STAT  DW      ?         ;LINE STATUS REGISTER
	M_STAT  DW      ?         ;MODEM STATUS REGISTER                
	TR      DW      ?         ;TRANSMITTER HOLDER REGISTER            
	RC      DW      ?         ; RECIEVER REGISTER                                
	LSB     DW      ?         ;FOR DLL i.e BAUD RATE
	MSB     DW      ?         ;FOR MDD i.e BAUD RATE
	
	ANSWER  DB      'ATA',0DH
	NO_ECHO DB      'ATE0',0DH
	HANGUP2 DB      'ATH',0DH
	HANGUP1 DB      '+++'        
	DIAL    DB      'ATDT'
	NUMBER  DB      '5840296',0DH   
	DIALING DB      0DH,0AH,'DALING .....                           $'
	INITI   DB      0DH,0AH,'INITIALIZING.....                      $'

	CUR_ROW DB      ?       ;ROW
	CUR_COL DB      ?       ;COLUMN
 
	CHAR    DB      ?
	OUTPUT  DB      ?       ; THE INPUT FROM THE MODEM
	FOR_LSB DB      ?
	FOR_MSB DB      ?

	NO_MODEM        DB      'MODEM NOT FOUND ON PORT COM1 $'

	FOR_PORT        DB      0DH,0AH,0DH,0AH,0DH,0AH,'                      CHOOSE PORT'
			DB      0DH,0AH,0DH,0AH,'         [1]   COMM1'
			DB      0DH,0AH,0DH,0AH,'         [2]   COMM2$'

	FOR_BAUD_RATE   DB      0DH,0AH,0DH,0AH,0DH,0AH,'                      CHOOSE BAUD RATE'
			DB      0DH,0AH,0DH,0AH,'         [1]   2,400'
			DB      0DH,0AH,0DH,0AH,'         [2]   9,600'
			DB      0DH,0AH,0DH,0AH,'         [3]   19,200'
			DB      0DH,0AH,0DH,0AH,'         [4]   28,800'
			DB      0DH,0AH,0DH,0AH,'         [5]   38,400'
			DB      0DH,0AH,0DH,0AH,'         [6]   57,600$'
	THANK_YOU       DB      'THANK YOU FOR USING CONNECTED!$'
;///////////////////////////// CODE SEGMENT ////////////////////////////////
.CODE
MAIN    PROC

	MOV     AX,@DATA
	MOV     DS,AX


	CALL    CLEAR_SCREEN
	CALL    ASK_PORT        ;FUNCTION THAT ASKS WHERE THE MODEM IS INSTALLED
	CALL    SET_BAUD_RATE   ;SET THE BAUD RATE


	CALL    INITialize

	LEA     DI,NO_ECHO
	CALL    DIALL

	CALL    CHAT
	CALL    CLEAR_SCREEN

	LEA     DX,THANK_YOU
	CALL    DISPLAY_STRING

	CALL    EXIT

MAIN     ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;FOR CHATTING;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE
CHAT    PROC

	CALL CLEAR_SCREEN


   FOR: MOV     AH,6                    ;INPUT WITHOUT ECHO
	MOV     DL,0FFH
	INT     21H
	JZ      NO_CHARS                 ;IF NO INPUT GO TO THE END OF LOOP

	MOV     CHAR,AL                  ; SAVE THE CHARACTER IN CHAR       

	MOV     AH,2                    ;OUTPUT THE CHAR FOR ECHO PURPOSE
	MOV     DL,AL
	INT     21H
	
	CMP     CHAR,05H                ;CTRL-E FOR EXIT
	JE      OOPS
	
	MOV     DX,PORT                 ;MOVE THE PORT NUMBER I.E 2F8
	OUT     DX,AL                   ; OUTPUT THE CHAR TO THE 2F8

	CMP     CHAR,0DH
	JE      ENTER_PRESSED

   CHECK_THR_EMPTY:

	MOV     DX,L_STAT               ; LINE STATUS REGISTER
	IN      AL,DX
	TEST    AL,00100000B            ;CHECK TO SEE IF TBR IS EMPTY
	JZ      CHECK_THR_EMPTY

    CHECK_TBR_EMPTY:
	
	MOV     DX,L_STAT               ; LINE STATUS REGISTER
	IN      AL,DX
	TEST    AL,01000000B            ;CHECK TO SEE IF TBR IS EMPTY
	JZ      CHECK_TBR_EMPTY

   NO_CHARS:                            ; A JUMP IF NO INPUT IS GIVEN

       MOV     DX,L_STAT               ; LINE STATUS REGISTER
       IN      AL,DX                   ;LINE STATUS REGISTER
       TEST    AL,00000001B            ;CHECK TO SEE IF RBR IS FULL
       JNZ     SCREEN

       BACK2:                           ;BAK

       MOV      AH,3            ;GETTING THE CURSOR POSITION
       MOV      BH,0
       INT      10H
       CMP      DL,79           ;IF THELINE IS FULL,GO TO THE NEXT LINE
       JE       ENTER_PRESSED
       
       MOV     CHAR,0H
       JMP     FOR                     ; GO TO THE BEGTINNING OF THE LOOP

   ;///////////////////////////////////////////////////////////////;
   SCREEN:
	MOV     DX,PORT
	IN      AL,DX                   ;GET FROM PORT

	CMP     CHAR,0DH
	JE      ENTER_PRESSED

	MOV     AH,2                    
	MOV     DL,AL                   ;OUTPUT AL
	INT     21H

      BACK1:                            ;BACK AFTER THE ENTER
	JMP     BACK2

       ;////////////////////// FOR THE NEW LINE AFTER ENTER///////////

     ENTER_PRESSED:
	MOV     AH,3
	MOV     BH,0
	INT     10H
	MOV     CUR_ROW,DH
	INC     CUR_ROW

	MOV     AH,2
	MOV     DH,CUR_ROW
	MOV     DL,0
	MOV     BH,0
	INT     10H
	JMP     BACK1

	;////////////////////// FOR EXIT WHEN "CTRL-E" PRESSED///////////

     OOPS:
	RET

CHAT    ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;INCLUDED FILES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
INCLUDE PRO.H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;THE END;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
END     MAIN
