  ; //            IMRAN'S PROJECT LIBRARY 1999 (C)
  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			;FOR INITIALIZING THE MODEM 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.code           ;FOR INITIALIZING THE MODEM
initIALIZE    proc

	push    ax      ;       SAVING ALL
	push    dx      ;       THE 
	push    si      ;       REGISTERS
	push    di      ;
	PUSH    CX

	MOV     CX,40000
	L1:
	LOOP L1
	MOV     CX,40000
	
	mov     al,10000000b    ;SET BIT 8 "ON" FOR SETTING THE BAUD RATE
	mov     dx,L_CTRL       
	out     dx,al

	L2:
	LOOP L2
	MOV     CX,40000

	mov     dx,LSB          ;SET THE LSB REGISTER
	mov     al,FOR_LSB  
	out     dx,al

	L3:
	LOOP L3
	MOV     CX,40000

	mov     dx,MSB          ;SET THE MSB REGISTER
	mov     al,FOR_MSB
	out     dx,al

	L4:
	LOOP L4
	MOV     CX,40000

	mov     dx,L_CTRL       ; SHUT DOWN THE ACCESS TO THE LSB AND MSB
	mov     al,00011011b    ; AND SETTING THE STOP/PARITY/WORD LENGTH BITS "ON"
	out     dx,al

	L5:
	LOOP L5
	MOV     CX,40000

	mov     dx,M_CTRL       ;SETTING THE...I DON'T REMEMBER BITS ON IN MODEM CONTROL
	mov     al,3
	out     dx,al

	L6:
	LOOP L6


	POP     CX
	pop     di
	pop     si
	pop     dx
	pop     ax

	ret

INITIALIZE    ENDP
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;                       CLEAR THE SCREEN
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE

CLEAR_SCREEN    PROC
	push    ax
	push    dx
	push    si
	push    di
	push    cx

	mov     ah,0            ;SET THE GRAPHIC MODE
	mov     al,03h
	int     10h

	pop     cx
	pop     di
	pop     si
	pop     dx
	pop     ax

	RET

CLEAR_SCREEN    ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;                       TO EXIT THE PROGRAM
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.CODE                   ;       TO EXIT
exit    PROC

	mov     ax,4C00h
	int     21h
	ret
EXIT    ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;                               OUT PUT THE STRING
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE
DISPLAY_STRING  PROC
	push    ax
	push    dx
	push    si
	push    di
	push    cx

	mov     ah,9            ;OUTPUT THE MENU
	int     21h

	pop     cx
	pop     di
	pop     si
	pop     dx
	pop     ax

	RET

DISPLAY_STRING ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE
SET_BAUD_RATE    PROC

	CALL    CLEAR_SCREEN

	LEA     DX,FOR_BAUD_RATE        ;DISPLAY THE BAUD RATE MENU
	CALL    DISPLAY_STRING          

	MOV     AH,1                    ;INPUT THE CHOICE
	INT     21H

	CMP     AL,'1'          ;FOR    2400
	JNE     L19200
	MOV     FOR_LSB,30H
	MOV     FOR_MSB,00H
	JMP     OK

   L19200:
	CMP     AL,'3'          ;FOR 19200
	JNE     L38400
	MOV     FOR_LSB,06H
	MOV     FOR_MSB,00H
	JMP     OK

   L38400:
	CMP     AL,'4'          ;FOR 38400
	JNE     L57600
	MOV     FOR_LSB,03H
	MOV     FOR_MSB,00H
	JMP     OK

   L57600:
	CMP     AL,'5'          ;FOR 57600
	JNE     L9600
	MOV     FOR_LSB,02H
	MOV     FOR_MSB,00H
	JMP     OK


   L9600:
	MOV     FOR_LSB,0CH
	MOV     FOR_MSB,00H

    OK:

    RET


SET_BAUD_RATE    ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE
ASK_PORT        PROC


	LEA     DX,FOR_PORT
	CALL    DISPLAY_STRING

	MOV     AH,1
	INT     21H

	CMP     AL,'1'
	JE      FOR_COM1

	CMP     AL,'2'
	JE      FOR_COM2

	CALL    EXIT

   FOR_COM1:
	MOV     PORT,3F8H
	MOV     L_CTRL,3F8H+3H         ;LINE CONTROL REGISTER
	MOV     M_CTRL,3F8H+4H         ;MODEM CONTROL REGISTER
	MOV     L_STAT,3F8H+5H         ;LINE STATUS REGISTER
	MOV     M_STAT,3F8H+6H         ;MODEM STATUS REGISTER                
	MOV     TR,3F8H+0H         ;TRANSMITTER HOLDER REGISTER            
	MOV     RC,3F8H+0H         ; RECIEVER REGISTER                                
	MOV     LSB,3F8H+0H         ;FOR DLL i.e BAUD RATE
	MOV     MSB,3F8H+1H         ;FOR MDD i.e BAUD RATE

	MOV     DX,M_CTRL
	MOV     AL,3
	OUT     DX,AL


	MOV     DX,M_STAT
	IN      AL,DX
	TEST    AL,30H
	JNZ     BYE               ; IF PRESENT THE CONTINUE,ELSE DIAPLEY STRING AND EXIT
	CALL    CLEAR_SCREEN
	LEA     DX,NO_MODEM
	CALL    DISPLAY_STRING
	CALL    EXIT

   FOR_COM2:
	MOV     PORT,2F8H
	MOV     L_CTRL,2F8H+3H         ;LINE CONTROL REGISTER
	MOV     M_CTRL,2F8H+4H         ;MODEM CONTROL REGISTER
	MOV     L_STAT,2F8H+5H         ;LINE STATUS REGISTER
	MOV     M_STAT,2F8H+6H         ;MODEM STATUS REGISTER                
	MOV     TR,2F8H+0H         ;TRANSMITTER HOLDER REGISTER            
	MOV     RC,2F8H+0H         ; RECIEVER REGISTER                                
	MOV     LSB,2F8H+0H         ;FOR DLL i.e BAUD RATE
	MOV     MSB,2F8H+1H         ;FOR MDD i.e BAUD RATE

	MOV     DX,M_CTRL
	MOV     AL,3
	OUT     DX,AL

	MOV     DX,M_STAT
	IN      AL,DX
	TEST    AL,30H
	JNZ     BYE            ; IF PRESENT THE CONTINUE,ELSE DIAPLEY STRING AND EXIT

	CALL    CLEAR_SCREEN
	LEA     DX,NO_MODEM
	CALL    DISPLAY_STRING
	CALL    EXIT

 BYE:
	RET    

ASK_PORT        ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.CODE                   ; TO DIAL THE NUMBER
DIALL    PROC

 
	MOV     CX,20
	

GO:     MOV     DX,PORT
	MOV     AL,[DI]
	OUT     DX,AL

   HOLD:
	MOV     AH,3
	MOV     DX,1
	INT     14H
	TEST    AH,00100000B
	JZ      HOLD

	INC     DI
	MOV     AL,[DI]
	CMP     AL,0
	JE      QUIT_LOOP
	
	LOOP    GO

    QUIT_LOOP:

	RET

DIALL   ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ENDP
